<?php

/**
 (c) DHTMLX Ltd, 2011
 Licensing: You allowed to use this component for free under GPL or you need to obtain Commercial/Enterprise license to use it in non-GPL project
 Contact: sales@dhtmlx.com
 **/




require_once('spreadsheet_common.php');

function get_sh_obj() {
	global $base_url;
	$sh_cfg = new SpreadsheetCfg();
	$sh_cfg->set('prefix', '');
	$sh_cfg->set('plugin', $base_url.'/'.drupal_get_path('module', 'spreadsheet').'/');
	$sh_cfg->set('connector',  $base_url.'/'.drupal_get_path('module', 'spreadsheet').'/spreadsheet_data.php');
	return $sh_cfg;
}

function sh_check($content) {
	$sh_cfg = get_sh_obj();
	$ver = phpversion();
	$ver_main = (int) substr($ver, 0, 1);
	if ( $ver_main < 5)
		return __('Installation error: Spreadsheet plugin requires PHP 5.x', 'spreadsheet');
	sh_load_dump();
	$content = preg_replace_callback($sh_cfg->get('pattern'), "sh_replace", $content);
	return $content;
}

function sh_replace($matches) {
	$sh_cfg = get_sh_obj();
	$options = Array();
	if (isset($matches[1])) {
		$ms = Array();
		$matches[1] = html_entity_decode($matches[1]);
		preg_match_all($sh_cfg->get('pattern_param'), $matches[1], $ms);
		
		if (isset($ms[1])) {
			for ($i = 0; $i < count($ms[1]); $i++) {
				$options[trim($ms[1][$i])] = trim($ms[2][$i]);
			}
		}
	}

	$matches = explode(":",$matches[1]);
	foreach ($options as $name => $value) {
		$sh_cfg->set($name, $value);
	}
	if (!isset($options['height']))
		$sh_cfg->set('autoheight', 'true');

	$text = $sh_cfg->get_spreadsheet_client();
	return $text;
}

function sh_load_dump($drop = false) {
	global $databases;
	$db = $databases['default']['default'];
	$prefix = $db['prefix'];
	$result = db_table_exists($prefix.'dhx_data');
	if ($result == false) {
		$result = db_table_exists($prefix."data");
		if (!$result) {
			$sh_cfg = new SpreadsheetCfg();
			$queries = $sh_cfg->get('queries');
			for ($i = 0; $i < count($queries); $i++) {
				$query = str_replace('#__', $prefix, $queries[$i]);
				db_query($query);
			}
		} else {
			// rename tables
			$tables_list = array("data", "header", "sheet", "triggers", "user");
			for ($i = 0; $i < count($tables_list); $i++)
				db_query("ALTER TABLE {$prefix}{$tables_list[$i]} RENAME TO {$prefix}dhx_{$tables_list[$i]}");
		}
	}

	$result = db_table_exists($prefix."dhx_triggers");
	if (!db_field_exists($prefix."dhx_triggers", "sheetid")) {
		// migrate call
		require_once(dirname(__FILE__).'/codebase/php/migrate.php');
		require_once(dirname(__FILE__).'/codebase/php/db_common.php');

		$db_host = $db['host'];
		$db_user = $db['username'];
		$db_pass = $db['password'];
		$db_name = $db['database'];
		$db_prefix = $db['prefix'];

		$res=mysql_connect($db_host,$db_user,$db_pass);
		mysql_select_db($db_name);

		$wrapper = new MySQLDBDataWrapper($res, null);
		$mig = new dhxMigrate($wrapper, $db_prefix.'dhx_');
		$mig->update();
	}
}


?>